
;- Initialisation
If InitEngine3D() = 0
  MessageRequester( "Error" , "Can't initialize 3D, check if engine3D.dll is available" , 0 )
  End
ElseIf InitSprite() = 0 Or InitKeyboard() = 0 Or InitMouse() = 0
  MessageRequester( "Error" , "Can't find DirectX 7.0 or above" , 0 )
  End
EndIf

result = MessageRequester("Lava shader","Full Screen ?",#PB_MessageRequester_YesNo)
If result = 6     
  FullScreen=#True
  ExamineDesktops()
  OpenScreen(DesktopWidth(0),DesktopHeight(0),DesktopDepth(0),"Lava shader",#PB_Screen_SmartSynchronization,DesktopFrequency(0))
Else           
  FullScreen=#False
  OpenWindow(0,0, 0, 800 , 600 ,"Lava shader",#PB_Window_ScreenCentered)
  OpenWindowedScreen(WindowID(0),0,0, 800, 600,0,0,0,#PB_Screen_SmartSynchronization )
EndIf

;- Ressources
Add3DArchive("shaders\", #PB_3DArchive_FileSystem  )
Add3DArchive("textures\", #PB_3DArchive_FileSystem  )
Add3DArchive("meshes\", #PB_3DArchive_FileSystem  )
Add3DArchive("materials\", #PB_3DArchive_FileSystem  )


;- Mesh
Parse3DScripts()
LoadMesh   (1 , "volcano2.mesh")
CreateEntity(1,   MeshID(1),  #PB_Material_None,0,0,0)
RotateEntity(1,0,-20,0,#PB_Relative)
  

;- Light
AmbientColor($555555)
CreateLight(1,$FFFFFF,100,50,100)

;- Camera
CreateCamera(0, 0,0,100,100)
CameraBackColor(0,$AA7755)
CameraLocate(0, 0, 50, 75)
CameraLookAt(0, 0 , 10, 0)

Repeat

  If FullScreen = #False
    While WindowEvent():Wend
  EndIf
  ExamineKeyboard()
  ExamineMouse()
  movez = MouseWheel()
  If movez <> 0
    MoveCamera(0,0,0,movez*2)
  EndIf


  RenderWorld()
  FlipBuffers()
  
  If KeyboardReleased(#PB_Key_F1)
    MessageRequester("FPS",StrF(Engine3DFrameRate(#PB_Engine3D_Average)) )
  EndIf
  
  Until KeyboardPushed(#PB_Key_Escape)

End

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 54
; FirstLine = 7
; Executable = C:\0\fire.exe
; DisableDebugger